/*!
 * @brief vision process module
 * $Date$
 * @author Nemoto,Mizoguchi lab,Tokyo University of Science
 * @mail:j7507640@ed.noda.tus.ac.jp
 * $Id$
 */

#include <iostream>
#include <string>
using namespace std;
#include "global.h"

typedef struct HSV_ALL_Data{
	double H;
	double S;
	double V;
}HSVcolor;

typedef struct HSV_HS_Data{
	int H;
	int S;
}HScolor;

typedef struct HS_histgram{
	int x;
	int y;
	double val;
}HShist;

typedef struct Cluster_Data{
	int pt;
	int clpt;
	int clnum[BIT8*BIT8];
	int ptx[BIT8*BIT8];
	int pty[BIT8*BIT8];
	int clx[BIT8*BIT8];
	int cly[BIT8*BIT8];
}CLdata;


void rgb_YCbCr(unsigned char R, unsigned char G, unsigned char B, HSVcolor* hsvcolor);
void rgb_hsv(unsigned char R, unsigned char G, unsigned char B, HSVcolor* hsvcolor);

double min_col(unsigned char r, unsigned char g, unsigned char b);
double max_col(unsigned char r, unsigned char g, unsigned char b);

void Crop(IplImage* src,IplImage* img, CvPoint pt1, CvPoint pt2);
void makeHist(IplImage* ext, double hist[][BIT8],HScolor hs[][BIT8][BIT8]);
void upHist(double histgram[][BIT8], double newhist[][BIT8], HShist hshist[], int count);
void getGaussian(CLdata* cluster, double histgram[][BIT8], double gaussian[][BIT8]);
void NNClustering(double clusterhist[][BIT8], CLdata* cluster, int threshold);
void ColorSpaceLoad(HScolor hs[][BIT8][BIT8],string c_space);
void inputClusterData(IplImage* src,CLdata *cluster);
void MedianFilter(double hist[][BIT8]);
void dimensionless(double histgram[][BIT8]);
double median(double m[]);
void RectDetec(double histgram[][BIT8],HScolor hstable[][BIT8][BIT8],IplImage* img,int *_proxmax,int *_proymax,CvPoint *_xy,CvPoint *_xy1);
void NoiseFilter(double histgram[][BIT8]);
void inputHShist(double gaussian[][BIT8],HShist hsGaussian[],int &plot_count);
void OutputHsv(double histgram[][BIT8],IplImage* hsv);
void OutputGau(double gaussian[][BIT8],IplImage* gau);
void ExtHistInit(double ExtHist[][BIT8]);
void initHist(double hist[][BIT8]);
void initGau(double gau[][BIT8]);
void on_mouse(int event, int x, int y, int flags, void *param);
void ColorExtract2(IplImage* target,IplImage *img,double histgram[][BIT8],HScolor hstable[][BIT8][BIT8]);

void OutputExt(double histgram[][BIT8],IplImage* hsg);
